'use strict';

/* Controllers */

angular.module('PorAcasoApp.controllers', [])
  .controller('postsController', function($scope, $location, $spMenu, blogAPI, $sce) {
  	$scope.posts = [];
  	$scope.currentCategory = '';
  	$scope.currentPostType = '';
  	$scope.loading = true;
  	$scope.enableBack = false;
  	$scope.showError = false;
  	$scope.showListing = true;
  	$scope.paginationBusy = true;
    $scope.subheader = true;
    
    
    $scope.toggleSubheader = function() {
    	
    	if ($scope.subheaderEnbaled) {
	    	if ($scope.subheader) {
	    		$scope.subheader = false;
	    	} else {
	    		$scope.subheader = true;
	    	}
    	}
    }
    
    $scope.goToPosts = function(category, posttype) {
    	if (!posttype)
    		posttype="news";
    		
    	
  		$scope.posts = [];
  		$scope.currentCategory = category;
  		$scope.currentPostType = posttype;
	  	$scope.loading = true;
	  	$scope.enableBack = false;
	  	$scope.showError = false;
	  	$spMenu.hide();
	  	$scope.page = 1;
  		
  		blogAPI.getPosts(category, posttype, $scope.page).success(function (response) {
	        $scope.posts = response.posts;
	        
    		$scope.subheader=true;
    		$scope.subheaderEnbaled=true;
    		$scope.legendSubheader=false;
	    	
	        $scope.loading = false;
	        $scope.showError = false;
	        if (!category) {
	        	$scope.currentCategory = 0;
	        }
	        
	    }).
	    error(function(data, status, headers, config) {
	    	$scope.loading = false;
	      	$scope.showError = true;
	      	$scope.error = status;
	    });
  	}
  	
	$scope.goToPosts('', 'news');
   
  	$scope.goToPost = function(id, type) {
  		
  		if (typeof type == 'undefined')
  			type = "news";
  		
  		$scope.oldsubheaderTitle = $scope.subheaderTitle;
  		$scope.subheaderTitle = false;
  		$scope.post = {"content":' '};
  		$scope.enableBack = true;
  		$scope.effect = "go";
  		$scope.showPost = true;
  		$scope.postLoading = true;
  		$scope.lockListing = "locked";
  		$spMenu.hide();
  		$scope.subheader = false;
  	
  		
  		blogAPI.getPost(id, type).success(function (response) {
	        $scope.post = response.post;
	        $scope.postLoading = false;
	        $scope.showError = false;
	        if (response.post.type == 'videos') { 
	        	console.log("its video!");
				var url = response.post.custom_fields.videos_url[0];
				var videoid = url.match(/(?:https?:\/{2})?(?:w{3}\.)?youtu(?:be)?\.(?:com|be)(?:\/watch\?v=|\/)([^\s&]+)/);
				console.log(videoid[1]);
				if(videoid[1]) {
				   $scope.post.embed = $sce.trustAsResourceUrl("http://youtube.com/embed/"+videoid[1]);
				}
			}
	    }).
	    error(function(data, status, headers, config) {
	    	$scope.postLoading = false;
	      	$scope.showError = true;
	      	$scope.error = status;
	      	$scope.subheaderTitle = false;
	    });
  	}
  	
  	$scope.goBack = function(id) {
  		$scope.effect = "back";
  		$scope.showPost = false;
  		$scope.post = false;
  		$scope.enableBack = false;
  		$scope.lockListing = "";
  		$scope.subheaderTitle = $scope.oldsubheaderTitle;
  		if ($scope.subheaderEnbaled)
  			$scope.subheader = true;
  	}
  	
  	$scope.loadMore = function() {
  		if ($scope.loading) return;
  		$scope.loading = true;
  		
  		$scope.page = $scope.page+1;
  		
  		blogAPI.getPosts($scope.currentCategory, $scope.currentPostType, $scope.page).success(function (response) {

		    for (var i = 0; i < response.posts.length; i++) {
		        $scope.posts.push(response.posts[i]);
		      }
		      $scope.loading = false;
	   }).
	   error(function() {
	   	$scope.page = $scope.page-1;
	   	$scope.loading = false;
	   });
  	}

  })
  .controller('postController', function($scope, $routeParams, blogAPI) {
	$scope.post = '';
  	$scope.id = $routeParams.id;
  	$scope.loading = true;
  	$scope.enableBack = true;
  	$scope.show_error = false;
  	$scope.effect = "back";
  	
	blogAPI.getPost($scope.id).success(function (response) {
        $scope.post = response.post;
        $scope.loading = false;
    }).
    error(function(data, status, headers, config) {
    	$scope.loading = false;
      	$scope.show_error = true;
      	$scope.error = status;
    });
    
  });
