'use strict';

/* Directives */


angular.module('PorAcasoApp.directives', []).directive('socialstats',['$http', function($http) {
        return {
            restrict: 'E',
            link: function (scope, elem, attrs) {
	            if (attrs.network == 'facebook') {
	              $http({method: 'JSONP', cache: true, url: 'http://graph.facebook.com/?ids='+attrs.url+'&callback=JSON_CALLBACK'}).then(function(data){
	                	if (attrs.action == 'comments') {
	                		if (typeof data.data[attrs.url].comments !== "undefined")
	                			elem.html('<i class="fa fa-comments-o"></i> <span class="socialstats">'+data.data[attrs.url].comments+'</span>');
	                	} else {
	                		if (typeof data.data[attrs.url].shares !== "undefined")
	                			elem.html('<i class="fa fa-thumbs-o-up"></i> <span class="socialstats">'+data.data[attrs.url].shares+'</span>');
	                	}
	               }); 
	            } else {
	            	$http({method: 'JSONP', cache:true, url: 'https://cdn.api.twitter.com/1/urls/count.json?url='+attrs.url+'&callback=JSON_CALLBACK'}).then(function(data){
	                	if (typeof data.count !== "undefined")
	                		elem.html('<i class="fa fa-twitter"></i> <span class="socialstats">'+data.count+'</span>');
	               }); 
	            }
            }
        };
    }])
    .directive('fbComments', function() {
   return {
    restrict: 'C',
    link: function(scope, element, attributes) { 
      element[0].dataset.href = document.location.href;
      return typeof FB !== "undefined" && FB !== null ? FB.XFBML.parse(element.parent()[0]) : void 0;
    }
  }})
  .directive('share', function() {
   return {
    restrict: 'A',
    link: function(scope, element, attr) { 
      element.bind("click", function() {
      	window.plugins.socialsharing.share(attr.message, null, attr.image, attr.url);
      });
    }
  }})
   .directive('categorymenu', function($http) {
   return {
    restrict: 'E',
    scope: {
    	active: "@active",
    	onItemClick: "&"
    },
    template: '<div class="categorymenu-holder"><ul class="nav nav-pills" role="tablist"><li ng-class="{active: active==false}" ng-click="onItemClick()"><a href="#">Todas</a></li><li ng-repeat="category in categories" ng-class="{active: active == category.id}"><a href="#" ng-click="'+"onItemClick({category:category.id}, {posttype:'news'})"+'">{{category.title}}</a></li></ul></div>',
    link: function(scope, element, attr) {
	    $http({method: 'JSONP', cache: true, url: 'http://ocponline.com.br/api/get_category_index?callback=JSON_CALLBACK'}).then(function(data){
	       	scope.categories = data.data.categories;
	    });
    }
  }})
  .directive('slidingarea', function($http, $swipe) {
   return {
    restrict: 'A',
    link: function(scope, element, attr) {
    	var init_x;
    	var started=0;
    	var scroll=0;
	    $swipe.bind(element, {
        'start': function(coords, event) {
          init_x = coords.x;
          console.log("started");
          started=true;
        },
        'move': function(coords, event) {
        	if (started == true) {
        		scroll = (coords.x-init_x)-scroll;
        		console.log(scroll);
        		if (scroll < 0) {
          			element.find("ul").css("marginLeft", scroll+"px");
          		}
          	}
        },
        'end': function() {
        	started=false;
        	console.log("ended");
        },
        'cancel': function() {
        	started=false;
        	console.log("ended");
        }
     });
    }
  }})
  .directive('ngHtmlCompile', function($compile) {
	return {
	    restrict: 'A',
	    link: function(scope, element, attrs) {
		scope.$watch(attrs.ngHtmlCompile, function(newValue, oldValue) {
		    element.html(newValue);
		    $compile(element.contents())(scope);
		});
	    }
	}
    });
