'use strict';

/* Services */
angular.module('PorAcasoApp.services', []).
  factory('blogAPI', function($http) {

    var blogAPI = {};
	
    blogAPI.getPosts = function(category, posttype, page) {
    	var query = '';
    	var method = 'get_posts';
    	
    	if (typeof category !== "undefined") {
    		query = query+"cat="+category+"&";
    		method = "get_category_posts";
    	}
    	
    	if (typeof posttype !== "undefined") {
    		method = "get_posts";
    		query = query+"post_type="+posttype+"&";
    	}
    	
    	if (typeof page !== "undefined")
    	query = query+"page="+page+"&";
    	
    	console.log(method+"?"+query);
    	
      return $http({
        method: 'JSONP',
        cache: true,
        url: 'http://ocponline.com.br/api/'+method+'?'+query+'callback=JSON_CALLBACK'
      });
    };
   
   
    
     blogAPI.getPost = function(id, type) {
     	console.log('http://ocponline.com.br/api/get_post?id='+id+'&post_type='+type+'&callback=JSON_CALLBACK');
      return $http({
        method: 'JSONP', 
        cache: false,
        url: 'http://ocponline.com.br/api/get_post?id='+id+'&post_type='+type+'&callback=JSON_CALLBACK'
      });
    };
    
    blogAPI.getCategories = function() {
      return $http({
        method: 'JSONP', 
        cache: false,
        url: 'http://ocponline.com.br/api/get_category_index?callback=JSON_CALLBACK'
      });
    };

    return blogAPI;
  });
